    MODULE etat0_heldsz_mod
         USE icosa
      IMPLICIT NONE
  REAL(rstd),ALLOCATABLE::knewt_t(:),kfrict(:)
  REAL(rstd)::knewt_g
  TYPE(t_field),POINTER :: f_tetarappel(:)
  TYPE(t_field),POINTER :: f_clat(:)

CONTAINS
  
  SUBROUTINE test_etat0_heldsz
  USE icosa
  USE kinetic_mod
  IMPLICIT NONE
    TYPE(t_field),POINTER :: f_ps(:)
    TYPE(t_field),POINTER :: f_phis(:)
    TYPE(t_field),POINTER :: f_theta_rhodz(:)
    TYPE(t_field),POINTER :: f_u(:)
    TYPE(t_field),POINTER :: f_q(:)
    TYPE(t_field),POINTER :: f_Ki(:)
  
    REAL(rstd),POINTER :: Ki(:,:)
    INTEGER :: ind
    
    
    CALL allocate_field(f_ps,field_t,type_real)
    CALL allocate_field(f_phis,field_t,type_real)
    CALL allocate_field(f_theta_rhodz,field_t,type_real,llm)
    CALL allocate_field(f_u,field_u,type_real,llm)
    CALL allocate_field(f_Ki,field_t,type_real,llm)
    
    CALL etat0(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
    CALL kinetic(f_u,f_Ki)

    CALL writefield('ps',f_ps)
    CALL writefield('theta',f_theta_rhodz)
  END SUBROUTINE test_etat0_heldsz
   
    
  SUBROUTINE etat0(f_ps,f_phis,f_theta_rhodz,f_u, f_q)
  USE icosa
  IMPLICIT NONE
    TYPE(t_field),POINTER :: f_ps(:)
    TYPE(t_field),POINTER :: f_phis(:)
    TYPE(t_field),POINTER :: f_theta_rhodz(:)
    TYPE(t_field),POINTER :: f_u(:)
    TYPE(t_field),POINTER :: f_q(:)
  
    REAL(rstd),POINTER :: ps(:)
    REAL(rstd),POINTER :: phis(:)
    REAL(rstd),POINTER :: theta_rhodz(:,:)
    REAL(rstd),POINTER :: u(:,:)
    REAL(rstd),POINTER :: q(:,:,:)
    INTEGER :: ind
    REAL(rstd),POINTER::clat(:) 
    REAL(rstd),POINTER::tetarappel(:,:) 
    
    CALL allocate_field(f_tetarappel,field_t,type_real,llm)
    CALL allocate_field(f_clat,field_t,type_real)
    ALLOCATE(knewt_t(llm)); ALLOCATE( kfrict(llm)) 

    DO ind=1,ndomain
      CALL swap_dimensions(ind)
      CALL swap_geometry(ind)
      ps=f_ps(ind)
      phis=f_phis(ind)
      theta_rhodz=f_theta_rhodz(ind)
      tetarappel=f_tetarappel(ind) 
      u=f_u(ind)
      q=f_q(ind)
      q=1e2
      clat=f_clat(ind) 
      CALL compute_etat0_heldsz(ps, phis, theta_rhodz, u,clat,tetarappel)
    ENDDO
  END SUBROUTINE etat0

  SUBROUTINE compute_etat0_heldsz(ps, phis, theta_rhodz, u,clat,tetarappel)
  USE icosa
  USE disvert_mod
  USE pression_mod
  USE exner_mod
  USE geopotential_mod
  USE theta2theta_rhodz_mod
  IMPLICIT NONE  
  REAL(rstd),INTENT(OUT) :: ps(iim*jjm)
  REAL(rstd),INTENT(OUT) :: phis(iim*jjm)
  REAL(rstd),INTENT(OUT) :: theta_rhodz(iim*jjm,llm)
  REAL(rstd),INTENT(OUT) :: u(3*iim*jjm,llm)
  REAL(rstd),INTENT(OUT) :: clat(iim*jjm)
  REAL(rstd),INTENT(OUT) :: tetarappel(iim*jjm,llm) 
  
  INTEGER :: i,j,l,ij
  REAL(rstd) :: r
  REAL(rstd) :: theta(iim*jjm,llm)
  REAL(rstd) :: zsig
  INTEGER    :: lsup
  REAL(rstd) :: ddsin
  REAL(rstd) :: lon,lat
  REAL(rstd) :: p(iim*jjm,llm+1)
  REAL(rstd) :: alpha(iim*jjm,llm),beta(iim*jjm,llm)
  REAL(rstd) :: delta
  REAL(rstd) :: pks(iim*jjm),pk(iim*jjm,llm)
  REAL(rstd) :: phi(iim*jjm,llm)
  REAL(rstd) :: x  
  REAL(rstd) :: fact(3*iim*jjm)
  REAL(rstd) :: ut(3*iim*jjm,llm)

  REAL(rstd) :: teta0,ttp,delt_y,delt_z,eps
  REAL(rstd) :: k_f,k_c_a,k_c_s
  REAL(rstd) :: zz,ran1
  REAL(rstd) :: tetastrat,tetajl(iim*jjm,llm) 
  REAL(rstd) :: slat(iim*jjm) 
!-------------choces of parametes and get it  
     k_f=1.                !friction 
     CALL getin('k_j',k_f)
     k_f=1./(daysec*k_f)
     k_c_s=4.  !cooling surface
     CALL getin('k_c_s',k_c_s)
     k_c_s=1./(daysec*k_c_s)
     k_c_a=40. !cooling free atm
     CALL getin('k_c_a',k_c_a)
     k_c_a=1./(daysec*k_c_a)
     ! Constants for Teta equilibrium profile
     teta0=315.     ! mean Teta (S.H. 315K)
     CALL getin('teta0',teta0)
     ttp=200.       ! Tropopause temperature (S.H. 200K)
     CALL getin('ttp',ttp)
     eps=0.         ! Deviation to N-S symmetry(~0-20K)
     CALL getin('eps',eps)
     delt_y=60.     ! Merid Temp. Gradient (S.H. 60K)
     CALL getin('delt_y',delt_y)
     delt_z=10.     ! Vertical Gradient (S.H. 10K)
     CALL getin('delt_z',delt_z)
!-----------------------------------------------------------
    knewt_g=k_c_a 
    DO l=1,llm
       zsig=ap(l)/preff+bp(l)
       knewt_t(l)=(k_c_s-k_c_a)*MAX(0.,(zsig-0.7)/0.3) 
       kfrict(l)=k_f*MAX(0.,(zsig-0.7)/0.3) 
    ENDDO
         DO j=jj_begin-1,jj_end+1
           DO i=ii_begin-1,ii_end+1
             ij=(j-1)*iim+i
             CALL xyz2lonlat(xyz_i(ij,:),lon,lat)
	     clat(ij)=cos(lat) 
	     slat(ij)=sin(lat) 
            ENDDO
         ENDDO

    DO l=1,llm
       zsig=ap(l)/preff+bp(l)
       tetastrat=ttp*zsig**(-kappa)
         DO j=jj_begin-1,jj_end+1
           DO i=ii_begin-1,ii_end+1
             ij=(j-1)*iim+i
	     ddsin=slat(ij) 
	     tetajl(ij,l)=teta0-delt_y*ddsin*ddsin+eps*ddsin &
                -delt_z*(1.-ddsin*ddsin)*log(zsig)
	     tetajl(ij,l)=MAX(tetajl(ij,l),tetastrat) 
	     tetarappel(ij,l)=tetajl(ij,l) 
	    ENDDO
	  ENDDO
	ENDDO 
     
     DO j=jj_begin-1,jj_end+1
       DO i=ii_begin-1,ii_end+1
         ij=(j-1)*iim+i
         ps(ij)=100000.0
         phis(ij)=0.0
       ENDDO
     ENDDO
     

    CALL compute_pression(ps,p,1)     
    CALL compute_exner(ps,p,pks,pk,1)  
	theta(:,:)=tetarappel(:,:) 
    CALL compute_geopotential(phis,pks,pk,theta,phi,1)

	u=0.0 !!wind 0 
!============================================================
     DO l=1,llm
      DO j=jj_begin-1,jj_end+1
        DO i=ii_begin-1,ii_end+1
          ij=(j-1)*iim+i
	  CALL RANDOM_NUMBER(r); r = 0.0 
          theta(ij,l)=theta(ij,l)*(1.+0.0005*r)
       ENDDO
      ENDDO
     ENDDO
    CALL compute_theta2theta_rhodz(ps,theta,theta_rhodz,1)

  END SUBROUTINE compute_etat0_heldsz


	SUBROUTINE held_saurez(f_ps,f_theta_rhodz,f_u) 
	USE icosa
	    IMPLICIT NONE
    TYPE(t_field),POINTER :: f_theta_rhodz(:)
    TYPE(t_field),POINTER :: f_u(:)
    TYPE(t_field),POINTER :: f_ps(:)
    REAL(rstd),POINTER :: theta_rhodz(:,:)
    REAL(rstd),POINTER :: u(:,:)
    REAL(rstd),POINTER :: ps(:)
    REAL(rstd),POINTER :: tetarappel(:,:)
    REAL(rstd),POINTER :: clat(:)
    INTEGER::ind

    DO ind=1,ndomain
      CALL swap_dimensions(ind)
      CALL swap_geometry(ind)
      theta_rhodz=f_theta_rhodz(ind)
      u=f_u(ind)
      ps=f_ps(ind) 
      tetarappel=f_tetarappel(ind) 
      clat=f_clat(ind) 
      CALL compute_heldsz(ps,theta_rhodz,u,clat,tetarappel) 
    ENDDO
        END SUBROUTINE held_saurez 

	SUBROUTINE compute_heldsz(ps,theta_rhodz,u,clat,tetarappel) 
	USE icosa
	USE theta2theta_rhodz_mod
           IMPLICIT NONE
   REAL(rstd),INTENT(IN)::ps(iim*jjm) 
   REAL(rstd),INTENT(INOUT) :: theta_rhodz(iim*jjm,llm)
   REAL(rstd),INTENT(INOUT) :: u(3*iim*jjm,llm)
   REAL(rstd)::theta(iim*jjm,llm) 
   REAL(rstd),INTENT(IN)::tetarappel(iim*jjm,llm) 
   REAL(rstd),INTENT(IN):: clat(iim*jjm) 
   INTEGER :: i,j,l,ij

      CALL compute_theta_rhodz2theta(ps,theta_rhodz,theta,1)
    DO l=1,llm
      DO j=jj_begin-1,jj_end+1
        DO i=ii_begin-1,ii_end+1
          ij=(j-1)*iim+i
        theta(ij,l)=theta(ij,l) - dt*(theta(ij,l)-tetarappel(ij,l))* &
        (knewt_g+knewt_t(l)*clat(ij)**4 )
	ENDDO
      ENDDO
    ENDDO 
       CALL compute_theta2theta_rhodz(ps,theta,theta_rhodz,1)

	Do l=1,llm
	u(:,l)=u(:,l)*(1.-dt*kfrict(l))
	END DO

	  END SUBROUTINE compute_heldsz

END MODULE etat0_heldsz_mod
